#if defined(ARDUINO) && ARDUINO >= 100
  #include "Arduino.h"
#elif defined(ENERGIA)
  #include "Energia.h"
#else
  #include "WProgram.h"
#endif

#include "Voltmeter.h"

#define REFERENCE_VOLTAGE     1086030UL

// Code from http://provideyourown.com/2012/secret-arduino-voltmeter-measure-battery-voltage/
unsigned int readVcc() {
  // Read 1.1V reference against AVcc
  // set the reference to Vcc and the measurement to the internal 1.1V reference
  #if defined(__AVR_ATmega32U4__) || defined(__AVR_ATmega1280__) || defined(__AVR_ATmega2560__)
    ADMUX = _BV(REFS0) | _BV(MUX4) | _BV(MUX3) | _BV(MUX2) | _BV(MUX1);
  #elif defined (__AVR_ATtiny24__) || defined(__AVR_ATtiny44__) || defined(__AVR_ATtiny84__)
    ADMUX = _BV(MUX5) | _BV(MUX0);
  #elif defined (__AVR_ATtiny25__) || defined(__AVR_ATtiny45__) || defined(__AVR_ATtiny85__)
    ADMUX = _BV(MUX3) | _BV(MUX2);
  #else
    ADMUX = _BV(REFS0) | _BV(MUX3) | _BV(MUX2) | _BV(MUX1);
  #endif  
 
  delay(2); // Wait for Vref to settle
  ADCSRA |= _BV(ADSC); // Start conversion
  while (bit_is_set(ADCSRA, ADSC)); // measuring
 
  byte low  = ADCL; // must read ADCL first - it then locks ADCH  
  byte high = ADCH; // unlocks both
 
  unsigned int result = (high << 8) | low;
 
  //result = 1125300UL / result; // Calculate Vcc (in mV); 1125300 = 1.1*1023*1000

  // correct reference voltage for the attiny
  //result = 981690UL / result;

  // correct reference voltage for the attiny at 3.3V
  result = REFERENCE_VOLTAGE / result;
  return result; // Vcc in millivolts
}

